package demo;

import tree.model.*;

public class TestTreeBinary {
  public static void main(String[] args) {

    // Create a BinaryTree

    System.out.printf("Build binary tree of strings ...\n");
    System.out.printf("---------------------------- ...\n");

    BinaryTree<String> tree = new BinaryTree<String>();

    tree.insert("George");
    tree.insert("Michael");
    tree.insert("David");
    tree.insert("Adam");
    tree.insert("Mark");
    tree.insert("Maria");
    tree.insert("Peter");
    tree.insert("Daniel");
    tree.insert("Leonard");

    // Get tree size ..

    System.out.printf("The number of nodes is %d ...\n", tree.getSize() );

    // Traverse tree

    System.out.printf("\n");
    System.out.printf("Traverse Tree Inorder (sorted) ...\n");
    System.out.printf("------------------------------ ...\n");

    tree.inorder();

    System.out.printf("\n");
    System.out.printf("Traverse Tree Postorder ...\n");
    System.out.printf("------------------------------ ...\n");

    tree.postorder();

    System.out.printf("\n");
    System.out.printf("Traverse Tree Preorder ...\n");
    System.out.printf("------------------------------ ...\n");

    tree.preorder();

    // Search for an element

    System.out.printf("\n");
    System.out.printf("Search for specific elements ...\n");
    System.out.printf("------------------------------ ...\n");

    System.out.println("--- Is Peter in the tree? " + tree.search("Peter") + "\n");

    // Get a path from the root to Peter

    System.out.printf("--- Retrieve path from root to Peter ...\n");

    java.util.ArrayList<BinaryTree.TreeNode<String>>  path = tree.path("Peter");
    for (int i = 0; path != null && i < path.size(); i++)
       System.out.printf("--- %s \n", path.get(i).getElement());

    System.out.printf("\n");
    System.out.printf("Build binary tree of integers from array ...\n");
    System.out.printf("---------------------------------------- ...\n");

    Integer[] numbers = {2, 4, 3, 1, 8, 5, 6, 7};

    BinaryTree<Integer> intTree = new BinaryTree<Integer>(numbers);

    System.out.printf("--- Inorder (sorted): ");
    intTree.inorder();
    System.out.printf(" ...\n");

    System.out.printf("---------------------------------------- ...\n");
    System.out.printf("Finished ...\n");
  }
}
